#include "model.h"
#include "looptools.h"
#include "renconst.h"

	double precision S, T, U
	common /kinvars/ S, T, U

	integer Hel1, Hel2, Hel3, Hel4
	common /kinvars/ Hel1, Hel2, Hel3, Hel4

	double complex Pair11, Pair12, Pair7, Pair6, Pair8, Pair10
	double complex Pair9, Pair5, Pair3, Pair4, Pair1, Pair2, Eps29
	double complex Eps30, Eps9, Eps28, Eps10, Eps6, Eps3, Eps7
	double complex Eps11, Eps4, Eps12, Eps8, Eps20, Eps21, Eps18
	double complex Eps23, Eps24, Eps19, Eps22, Eps1, Eps2, Eps5
	double complex Eps27, Eps25, Eps13, Eps14, Eps26, Eps16, Eps17
	double complex Eps15, Abb109, Abb116, Abb142, Abb103, Abb34
	double complex Abb68, Abb70, Abb54, Abb137, Abb92, Abb170
	double complex Abb136, Abb99, Abb101, Abb17, Abb28, Abb33
	double complex Abb50, Abb141, Abb76, Abb161, Abb140, Abb39
	double complex Abb58, Abb104, Abb56, Abb110, Abb117, Abb143
	double complex Abb52, Abb63, Abb21, Abb1, Abb26, Abb11, Abb132
	double complex Abb81, Abb130, Abb2, Abb87, Abb133, Abb144
	double complex Abb3, Abb8, Abb89, Abb14, Abb135, Abb82, Abb134
	double complex Abb4, Abb115, Abb154, Abb118, Abb111, Abb145
	double complex Abb146, Abb112, Abb122, Abb83, Abb37, Abb49
	double complex Abb73, Abb75, Abb158, Abb98, Abb174, Abb175
	double complex Abb25, Abb38, Abb45, Abb121, Abb159, Abb79
	double complex Abb181, Abb178, Abb42, Abb61, Abb47, Abb66
	double complex Abb5, Abb107, Abb12, Abb148, Abb94, Abb150
	double complex Abb23, Abb96, Abb32, Abb167, Abb169, Abb106
	double complex Abb125, Abb36, Abb48, Abb72, Abb74, Abb139
	double complex Abb84, Abb97, Abb173, Abb138, Abb24, Abb20
	double complex Abb44, Abb119, Abb77, Abb162, Abb176, Abb40
	double complex Abb59, Abb46, Abb64, Abb22, Abb30, Abb93
	double complex Abb165, Abb6, Abb95, Abb15, Abb152, Abb108
	double complex Abb155, Abb105, Abb123, Abb85, Abb126, Abb86
	double complex Abb10, Abb128, Abb147, Abb9, Abb127, Abb129
	double complex Abb91, Abb35, Abb69, Abb71, Abb55, Abb157
	double complex Abb171, Abb172, Abb100, Abb102, Abb18, Abb29
	double complex Abb19, Abb51, Abb57, Abb53, Abb7, Abb114
	double complex Abb131, Abb88, Abb27, Abb90, Abb166, Abb113
	double complex Abb160, Abb80, Abb179, Abb43, Abb62, Abb67
	double complex Abb13, Abb149, Abb151, Abb168, Abb120, Abb180
	double complex Abb78, Abb163, Abb177, Abb41, Abb60, Abb65
	double complex Abb31, Abb164, Abb16, Abb153, Abb156, Abb124
	double complex AbbSum139, AbbSum128, AbbSum155, AbbSum45
	double complex AbbSum132, AbbSum149, AbbSum145, AbbSum10
	double complex AbbSum6, AbbSum148, AbbSum25, AbbSum30
	double complex AbbSum15, AbbSum13, AbbSum5, AbbSum9, AbbSum46
	double complex AbbSum44, AbbSum39, AbbSum38, AbbSum36
	double complex AbbSum37, AbbSum11, AbbSum17, AbbSum14
	double complex AbbSum16, AbbSum12, AbbSum3, AbbSum35, AbbSum52
	double complex AbbSum50, AbbSum51, AbbSum48, AbbSum29
	double complex AbbSum153, AbbSum152, AbbSum137, AbbSum57
	double complex AbbSum135, AbbSum150, AbbSum151, AbbSum126
	double complex AbbSum133, AbbSum136, AbbSum134, AbbSum55
	double complex AbbSum56, AbbSum53, AbbSum77, AbbSum127
	double complex AbbSum27, AbbSum28, AbbSum138, AbbSum154
	double complex AbbSum146, AbbSum147, AbbSum76, AbbSum75
	double complex AbbSum74, AbbSum102, AbbSum71, AbbSum73
	double complex AbbSum72, AbbSum70, AbbSum69, AbbSum34
	double complex AbbSum62, AbbSum99, AbbSum61, AbbSum59
	double complex AbbSum60, AbbSum32, AbbSum33, AbbSum58
	double complex AbbSum78, AbbSum47, AbbSum122, AbbSum129
	double complex AbbSum108, AbbSum82, AbbSum120, AbbSum103
	double complex AbbSum89, AbbSum140, AbbSum91, AbbSum124
	double complex AbbSum88, AbbSum20, AbbSum49, AbbSum54
	double complex AbbSum123, AbbSum109, AbbSum86, AbbSum130
	double complex AbbSum4, AbbSum142, AbbSum94, AbbSum143
	double complex AbbSum87, AbbSum95, AbbSum131, AbbSum90
	double complex AbbSum125, AbbSum113, AbbSum144, AbbSum96
	double complex AbbSum93, AbbSum141, AbbSum92, AbbSum118
	double complex AbbSum97, AbbSum119, AbbSum98, AbbSum116
	double complex AbbSum18, AbbSum114, AbbSum115, AbbSum117
	double complex AbbSum19, AbbSum26, AbbSum31, AbbSum81
	double complex AbbSum107, AbbSum21, AbbSum43, AbbSum104
	double complex AbbSum79, AbbSum105, AbbSum7, AbbSum80
	double complex AbbSum106, AbbSum1, AbbSum121, AbbSum85
	double complex AbbSum112, AbbSum83, AbbSum110, AbbSum8
	double complex AbbSum84, AbbSum111, AbbSum2, AbbSum64
	double complex AbbSum68, AbbSum100, AbbSum101, AbbSum63
	double complex AbbSum67, AbbSum65, AbbSum66, AbbSum23
	double complex AbbSum22, AbbSum24, AbbSum41, AbbSum40
	double complex AbbSum42
	common /abbrev/ Pair11, Pair12, Pair7, Pair6, Pair8, Pair10
	common /abbrev/ Pair9, Pair5, Pair3, Pair4, Pair1, Pair2
	common /abbrev/ Eps29, Eps30, Eps9, Eps28, Eps10, Eps6, Eps3
	common /abbrev/ Eps7, Eps11, Eps4, Eps12, Eps8, Eps20, Eps21
	common /abbrev/ Eps18, Eps23, Eps24, Eps19, Eps22, Eps1, Eps2
	common /abbrev/ Eps5, Eps27, Eps25, Eps13, Eps14, Eps26, Eps16
	common /abbrev/ Eps17, Eps15, Abb109, Abb116, Abb142, Abb103
	common /abbrev/ Abb34, Abb68, Abb70, Abb54, Abb137, Abb92
	common /abbrev/ Abb170, Abb136, Abb99, Abb101, Abb17, Abb28
	common /abbrev/ Abb33, Abb50, Abb141, Abb76, Abb161, Abb140
	common /abbrev/ Abb39, Abb58, Abb104, Abb56, Abb110, Abb117
	common /abbrev/ Abb143, Abb52, Abb63, Abb21, Abb1, Abb26
	common /abbrev/ Abb11, Abb132, Abb81, Abb130, Abb2, Abb87
	common /abbrev/ Abb133, Abb144, Abb3, Abb8, Abb89, Abb14
	common /abbrev/ Abb135, Abb82, Abb134, Abb4, Abb115, Abb154
	common /abbrev/ Abb118, Abb111, Abb145, Abb146, Abb112, Abb122
	common /abbrev/ Abb83, Abb37, Abb49, Abb73, Abb75, Abb158
	common /abbrev/ Abb98, Abb174, Abb175, Abb25, Abb38, Abb45
	common /abbrev/ Abb121, Abb159, Abb79, Abb181, Abb178, Abb42
	common /abbrev/ Abb61, Abb47, Abb66, Abb5, Abb107, Abb12
	common /abbrev/ Abb148, Abb94, Abb150, Abb23, Abb96, Abb32
	common /abbrev/ Abb167, Abb169, Abb106, Abb125, Abb36, Abb48
	common /abbrev/ Abb72, Abb74, Abb139, Abb84, Abb97, Abb173
	common /abbrev/ Abb138, Abb24, Abb20, Abb44, Abb119, Abb77
	common /abbrev/ Abb162, Abb176, Abb40, Abb59, Abb46, Abb64
	common /abbrev/ Abb22, Abb30, Abb93, Abb165, Abb6, Abb95
	common /abbrev/ Abb15, Abb152, Abb108, Abb155, Abb105, Abb123
	common /abbrev/ Abb85, Abb126, Abb86, Abb10, Abb128, Abb147
	common /abbrev/ Abb9, Abb127, Abb129, Abb91, Abb35, Abb69
	common /abbrev/ Abb71, Abb55, Abb157, Abb171, Abb172, Abb100
	common /abbrev/ Abb102, Abb18, Abb29, Abb19, Abb51, Abb57
	common /abbrev/ Abb53, Abb7, Abb114, Abb131, Abb88, Abb27
	common /abbrev/ Abb90, Abb166, Abb113, Abb160, Abb80, Abb179
	common /abbrev/ Abb43, Abb62, Abb67, Abb13, Abb149, Abb151
	common /abbrev/ Abb168, Abb120, Abb180, Abb78, Abb163, Abb177
	common /abbrev/ Abb41, Abb60, Abb65, Abb31, Abb164, Abb16
	common /abbrev/ Abb153, Abb156, Abb124, AbbSum139, AbbSum128
	common /abbrev/ AbbSum155, AbbSum45, AbbSum132, AbbSum149
	common /abbrev/ AbbSum145, AbbSum10, AbbSum6, AbbSum148
	common /abbrev/ AbbSum25, AbbSum30, AbbSum15, AbbSum13
	common /abbrev/ AbbSum5, AbbSum9, AbbSum46, AbbSum44, AbbSum39
	common /abbrev/ AbbSum38, AbbSum36, AbbSum37, AbbSum11
	common /abbrev/ AbbSum17, AbbSum14, AbbSum16, AbbSum12
	common /abbrev/ AbbSum3, AbbSum35, AbbSum52, AbbSum50
	common /abbrev/ AbbSum51, AbbSum48, AbbSum29, AbbSum153
	common /abbrev/ AbbSum152, AbbSum137, AbbSum57, AbbSum135
	common /abbrev/ AbbSum150, AbbSum151, AbbSum126, AbbSum133
	common /abbrev/ AbbSum136, AbbSum134, AbbSum55, AbbSum56
	common /abbrev/ AbbSum53, AbbSum77, AbbSum127, AbbSum27
	common /abbrev/ AbbSum28, AbbSum138, AbbSum154, AbbSum146
	common /abbrev/ AbbSum147, AbbSum76, AbbSum75, AbbSum74
	common /abbrev/ AbbSum102, AbbSum71, AbbSum73, AbbSum72
	common /abbrev/ AbbSum70, AbbSum69, AbbSum34, AbbSum62
	common /abbrev/ AbbSum99, AbbSum61, AbbSum59, AbbSum60
	common /abbrev/ AbbSum32, AbbSum33, AbbSum58, AbbSum78
	common /abbrev/ AbbSum47, AbbSum122, AbbSum129, AbbSum108
	common /abbrev/ AbbSum82, AbbSum120, AbbSum103, AbbSum89
	common /abbrev/ AbbSum140, AbbSum91, AbbSum124, AbbSum88
	common /abbrev/ AbbSum20, AbbSum49, AbbSum54, AbbSum123
	common /abbrev/ AbbSum109, AbbSum86, AbbSum130, AbbSum4
	common /abbrev/ AbbSum142, AbbSum94, AbbSum143, AbbSum87
	common /abbrev/ AbbSum95, AbbSum131, AbbSum90, AbbSum125
	common /abbrev/ AbbSum113, AbbSum144, AbbSum96, AbbSum93
	common /abbrev/ AbbSum141, AbbSum92, AbbSum118, AbbSum97
	common /abbrev/ AbbSum119, AbbSum98, AbbSum116, AbbSum18
	common /abbrev/ AbbSum114, AbbSum115, AbbSum117, AbbSum19
	common /abbrev/ AbbSum26, AbbSum31, AbbSum81, AbbSum107
	common /abbrev/ AbbSum21, AbbSum43, AbbSum104, AbbSum79
	common /abbrev/ AbbSum105, AbbSum7, AbbSum80, AbbSum106
	common /abbrev/ AbbSum1, AbbSum121, AbbSum85, AbbSum112
	common /abbrev/ AbbSum83, AbbSum110, AbbSum8, AbbSum84
	common /abbrev/ AbbSum111, AbbSum2, AbbSum64, AbbSum68
	common /abbrev/ AbbSum100, AbbSum101, AbbSum63, AbbSum67
	common /abbrev/ AbbSum65, AbbSum66, AbbSum23, AbbSum22
	common /abbrev/ AbbSum24, AbbSum41, AbbSum40, AbbSum42

	double complex cint1(2), cint2(2,2), cint3(2,2), cint4(2,2)
	double complex cint5(2), cint6(2), cint7(2), cint8(2,2)
	double complex cint9(3), cint10(3), cint11(3), cint12(3)
	double complex cint13(3), cint14(3), cint15(3), cint16(3)
	double complex cint17(3), cint18(3), cint19(3), cint20(3)
	double complex cint21(3), cint22(3), cint23(3,2), cint24(3,2)
	double complex cint25(3,2), cint26(3,2), cint27(3,2)
	double complex cint28(3,2), cint29(3,2,2), cint30(3,2,2)
	double complex cint31(3,2,2), cint32, cint33, cint34, cint35
	double complex cint36, cint37, cint38, cint39, cint40, cint41
	double complex cint42, cint43, cint44, cint45, cint46, cint47
	double complex cint48, cint49, cint50, cint51, cint52, cint53
	double complex cint54, cint55(4), cint56(4,4), cint57(4)
	double complex cint58(4,4), cint59(4,4), cint60(2), cint61(4)
	double complex cint62(2,2), cint63, cint64, cint65, cint66
	double complex cint67, cint68, cint69, cint70
	common /loopint/ cint1, cint2, cint3, cint4, cint5, cint6
	common /loopint/ cint7, cint8, cint9, cint10, cint11, cint12
	common /loopint/ cint13, cint14, cint15, cint16, cint17
	common /loopint/ cint18, cint19, cint20, cint21, cint22
	common /loopint/ cint23, cint24, cint25, cint26, cint27
	common /loopint/ cint28, cint29, cint30, cint31, cint32
	common /loopint/ cint33, cint34, cint35, cint36, cint37
	common /loopint/ cint38, cint39, cint40, cint41, cint42
	common /loopint/ cint43, cint44, cint45, cint46, cint47
	common /loopint/ cint48, cint49, cint50, cint51, cint52
	common /loopint/ cint53, cint54, cint55, cint56, cint57
	common /loopint/ cint58, cint59, cint60, cint61, cint62
	common /loopint/ cint63, cint64, cint65, cint66, cint67
	common /loopint/ cint68, cint69, cint70

	integer iint1(2,2,4), iint2(2,2,4), iint3(2,4,4,2)
	integer iint4(2,4,4,2), iint5(2,4,4), iint6(2,4,2)
	integer iint7(2,4,2), iint8(4,2), iint9(2,4), iint10(2,2)
	integer iint11, iint12, iint13, iint14, iint15, iint16, iint17
	integer iint18, iint19, iint20, iint21, iint22, iint23, iint24
	integer iint25, iint26, iint27, iint28, iint29, iint30, iint31
	integer iint32, iint33, iint34, iint35, iint36, iint37, iint38
	integer iint39, iint40, iint41, iint42, iint43, iint44, iint45
	integer iint46, iint47, iint48, iint49, iint50, iint51, iint52
	integer iint53, iint54, iint55(4,2,2), iint56(4,2,2)
	integer iint57(2,2), iint58(2,2,4), iint59(2), iint60(2)
	integer iint61(2,4), iint62(2,4), iint63(2,4,4), iint64(2,4,2)
	integer iint65(3), iint66(3), iint67(3), iint68(3)
	integer iint69(3,2), iint70(3,2), iint71(3,2,2), iint72(3,2,2)
	integer iint73(3,2,2), iint74(3,2,2,2), iint75(3,2,2,2)
	integer iint76, iint77, iint78, iint79, iint80, iint81, iint82
	integer iint83, iint84, iint85, iint86, iint87, iint88, iint89
	integer iint90, iint91, iint92, iint93, iint94, iint95, iint96
	integer iint97, iint98, iint99, iint100, iint101, iint102
	integer iint103, iint104, iint105, iint106, iint107, iint108
	integer iint109, iint110, iint111, iint112, iint113, iint114
	integer iint115, iint116, iint117, iint118, iint119(4,4,2)
	integer iint120(4,2), iint121(4,2)
	common /loopint/ iint1, iint2, iint3, iint4, iint5, iint6
	common /loopint/ iint7, iint8, iint9, iint10, iint11, iint12
	common /loopint/ iint13, iint14, iint15, iint16, iint17
	common /loopint/ iint18, iint19, iint20, iint21, iint22
	common /loopint/ iint23, iint24, iint25, iint26, iint27
	common /loopint/ iint28, iint29, iint30, iint31, iint32
	common /loopint/ iint33, iint34, iint35, iint36, iint37
	common /loopint/ iint38, iint39, iint40, iint41, iint42
	common /loopint/ iint43, iint44, iint45, iint46, iint47
	common /loopint/ iint48, iint49, iint50, iint51, iint52
	common /loopint/ iint53, iint54, iint55, iint56, iint57
	common /loopint/ iint58, iint59, iint60, iint61, iint62
	common /loopint/ iint63, iint64, iint65, iint66, iint67
	common /loopint/ iint68, iint69, iint70, iint71, iint72
	common /loopint/ iint73, iint74, iint75, iint76, iint77
	common /loopint/ iint78, iint79, iint80, iint81, iint82
	common /loopint/ iint83, iint84, iint85, iint86, iint87
	common /loopint/ iint88, iint89, iint90, iint91, iint92
	common /loopint/ iint93, iint94, iint95, iint96, iint97
	common /loopint/ iint98, iint99, iint100, iint101, iint102
	common /loopint/ iint103, iint104, iint105, iint106, iint107
	common /loopint/ iint108, iint109, iint110, iint111, iint112
	common /loopint/ iint113, iint114, iint115, iint116, iint117
	common /loopint/ iint118, iint119, iint120, iint121

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, Sfe3
	common /indices/ Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2
	common /indices/ Sfe3

	double complex Cloop(22), Ctree(7), MatF(22,7)
	common /coeff/ Cloop, Ctree, MatF
